package web._05._0302;


/**
 * 5-3
 * 1次職の抽象クラスです。
 *
 * @author akira_ishii
 *
 */
abstract class AbstractFirstJob extends MainCharacter {

	/**
	 * コンストラクタ
	 *
	 * @param genderCode 性別コード
	 * @param hairStyleCode 髪型コード
	 * @param eyeColorCode 目の色コード
	 */
	public AbstractFirstJob(String genderCode, String hairStyleCode, String eyeColorCode) {
		super(genderCode, hairStyleCode, eyeColorCode);
	}

	/**
	 * モンスターに攻撃します。
	 * 残りヒットポイントの6割をダメージとしてモンスターに与えます。
	 * 与えたダメージを結果として返します。
	 *
	 * @param monster モンスター
	 * @return モンスターに与えたダメージ
	 */
	public int attack(Monster monster) {
		int damage = (int)(this.hp * 0.6);
		monster.setHp(monster.getHp() - damage);

		return damage;
	}

	/**
	 * 情報を表示します。
	 * メインキャラクターの情報に加えて、職毎の特殊情報を表示します。
	 *
	 */
	public void viewInfo() {
		super.viewInfo();
		addInfo();
	}

	/**
	 * 職毎の特殊情報を表示します。
	 *
	 */
	abstract void addInfo();

}
