package web._05._0302;
import java.util.Random;

/**
 * 5-3-2
 * 2次職「AxMaster」を表すクラスです。
 *
 * @author akira_ishii
 *
 */
public class AxMaster extends Fighter implements IFighterSecondJob {

	/** マジックポイント */
	protected int mp;

	/**
	 * コンストラクタ
	 *
	 * @param genderCode 性別コード
	 * @param hairStyleCode 髪型コード
	 * @param eyeColorCode 目の色コード
	 */
	public AxMaster(String genderCode, String hairStyleCode, String eyeColorCode) {
		super(genderCode, hairStyleCode, eyeColorCode);
		this.hp = 160;
		this.sp = 40;
		this.mp = 5;
	}

	/**
	 * 攻撃をします。
	 * 通常、残りヒットポイントの8割をダメージとしてモンスターに与えます。
	 * 特殊攻撃が発動した場合は、1割の確率で残りヒットポイントの8割を追加ダメージとして加えます。
	 * 与えたダメージを結果として返します。
	 *
	 * @param Monster モンスター
	 * @return モンスターに与えたダメージ
	 */
	public int attack(Monster monster) {
		int damage = (int)(this.hp * 0.8);

		Random rnd = new Random();
		int num = rnd.nextInt(10);
		//発生確率約10%
		if(num == 9) {
			damage = damage + (int)(this.hp * 0.8);
		}

		return damage;
	}

	/**
	 * ヒットポイントの自動回復メソッド。
	 * 自身のヒットポイントをマジックポイントの半分回復させます。
	 *
	 */
	@Override
	public void autoHeal() {

		this.hp = this.hp + this.mp / 2;
		if(160 < this.hp) {
			this.hp = 160;
		}
	}

	/**
	 * MPを返します。
	 *
	 * @return MP スキルポイント
	 */
	public int getMp() {
		return this.mp;
	}

	/**
	 * MPを設定します。
	 *
	 * @param mp スキルポイント
	 */
	public void setMp(int mp) {
		this.mp = mp;
	}

	/**
	 * ステータスを表示します。
	 * ファイターの情報に加えて、MPを表示します。
	 *
	 */
	public void viewInfo() {
		super.viewInfo();
		System.out.println("MP：" + this.mp);
	}
}
