package web._05._0302;


/**
 * 5-1
 * 1次職「Fighter」を表すクラスです。
 *
 * @author akira_ishii
 *
 */
public class Fighter extends AbstractFirstJob {

	/** 盾の守備力 */
	protected int shield;

	/**
	 * コンストラクタ
	 *
	 * @param genderCode 性別コード
	 * @param hairStyleCode 髪型コード
	 * @param eyeColorCode 目の色コード
	 */
	public Fighter(String genderCode, String hairStyleCode, String eyeColorCode) {
		super(genderCode, hairStyleCode, eyeColorCode);
		this.hp = 100;
		this.sp = 30;
		this.shield = 5;
	}

	/**
	 * 特殊スキル「バッシュ」を使います。
	 * 残りヒットポイントの17割をダメージとしてモンスターに与えます。
	 * 与えたダメージを結果として返します。
	 * また、スキルポイントを10消費します。
	 *
	 * @param monster モンスター
	 * @return モンスターに与えたダメージ
	 */
	public int executeBash(Monster monster) {
		int damage = (int)(this.hp * 1.7);
		monster.setHp(monster.getHp() - damage);
		this.sp = this.sp - 10;

		return damage;
	}

	/**
	 * 特殊スキル「バッシュ」を使えるか判定します。
	 * スキルポイントが10以上で使用可能、それより小さい場合は使用不可となります。
	 *
	 * @return true：使用可 false：使用不可
	 */
	public boolean isExecutiveBash() {
		return 10 <= this.sp;
	}

	/**
	 * 盾の守備力を返します。
	 *
	 * @return 盾の守備力
	 */
	public int getShield() {
		return this.shield;
	}

	/**
	 * 盾の守備力を設定します。
	 *
	 * @param shield 盾の守備力
	 */
	public void setShield(int shield) {
		this.shield = shield;
	}

	/**
	 * Fighterの特殊情報を表示します。
	 *
	 */
	void addInfo() {
		System.out.println("盾の守備力：" + this.shield);
	}

}